<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet exclude-result-prefixes="saxon xlink eg dd xsi" extension-element-prefixes="saxon" version="1.0" xmlns="http://www.w3.org/1999/xhtml" xmlns:as="http://www.oasis-open.org/committees/cam" xmlns:camed="http://jcam.org.uk/editor" xmlns:dd="http://xml.btlabs.bt.co.uk/datadictionary" xmlns:eg="http://examplotron.org/0/" xmlns:saxon="http://icl.com/saxon" xmlns:xlink="http://www.w3.org/1999/xlink" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:look="http://jcam.org.uk/LookupLists">
	<xsl:param name="file">File name</xsl:param>
	<xsl:param name="path">d:/documents%20and%20settings/802051682/My%20Documents/MyProjects/research/jcamresreach/EMP%20Phase%203%20-%2001-09-2006%201054/Fulfilment%20Examples%20MPF/CAM%20Templates</xsl:param>
	<xsl:param name="stylesheet">styles.css</xsl:param>
	<xsl:output encoding="UTF-8" indent="yes" method="html"/>
	<xsl:variable name="nbsp"/>
	<xsl:template match="/">
		<xhtml>
			<head>
				<xsl:element name="link">
					<xsl:attribute name="rel">stylesheet</xsl:attribute>
					<xsl:attribute name="type">text/css</xsl:attribute>
					<xsl:attribute name="href"><xsl:value-of select="$stylesheet"/></xsl:attribute>
				</xsl:element>
			</head>
			<body>
				<xsl:apply-templates select="//as:Header"/>
				<xsl:apply-templates select="//as:AssemblyStructure"/>
				<xsl:apply-templates select="//as:Extension"/>
				<!--				<xsl:apply-templates select="//as:BusinessUseContext"/>
				<xsl:apply-templates select="/as:CAM/as:include" mode="extension"/>-->
			</body>
		</xhtml>
	</xsl:template>
	<xsl:template match="as:Header">
		<h1>
CAM Template:  			<xsl:value-of select="$file"/>
		</h1>
		<p class="footerNotice">
			<xsl:value-of select="$path"/>
		</p>
		<table class="CAM-InfoTable" width="100%">
			<tr>
				<td width="20%">Owner</td>
				<th width="80%">
					<xsl:value-of select="as:Owner"/>
				</th>
			</tr>
			<tr>
				<td>Version</td>
				<th>
					<xsl:value-of select="as:Version"/>
				</th>
			</tr>
			<tr>
				<td>Description</td>
				<td class="CAM-NewsCell">
					<xsl:value-of select="as:Description"/>
				</td>
			</tr>
			<tr>
				<td>Date</td>
				<td>
					<xsl:value-of select="as:DateTime"/>
				</td>
			</tr>
		</table>
		<xsl:apply-templates select="as:Parameters"/>
		<xsl:apply-templates select="as:Imports"/>
		<xsl:apply-templates select="as:Properties"/>
	</xsl:template>
	<xsl:template match="as:Parameters">
		<h2>Parameters</h2>
		<table border="1">
			<tr>
				<th>Name</th>
				<th>Usage</th>
				<th>Values</th>
				<th>Default Value</th>
				<th>xpath</th>
			</tr>
			<xsl:apply-templates select="as:Parameter"/>
		</table>
	</xsl:template>
	<xsl:template match="as:Parameter">
		<tr>
			<td>
				<xsl:value-of select="@name"/>
			</td>
			<td>
				<xsl:value-of select="@use"/>
			</td>
			<td>
				<xsl:value-of select="@values"/>
				<xsl:value-of select="$nbsp"/>
			</td>
			<td>
				<xsl:value-of select="@default"/>
				<xsl:value-of select="$nbsp"/>
			</td>
			<td>
				<xsl:value-of select="@xpath"/>
				<xsl:value-of select="$nbsp"/>
			</td>
		</tr>
	</xsl:template>
	<xsl:template match="as:AssemblyStructure">
		<h1>Assembly Structures</h1>
		<xsl:apply-templates select="as:Structure"/>
	</xsl:template>
	<xsl:template match="as:Element">
		<tr>
			<td>
				<div class="topicTextLeft">
					<xsl:value-of select="@path"/>
				</div>
			</td>
			<td>
				<div class="topicTextLeft">
					<xsl:apply-templates select="as:Rule"/>
					<xsl:value-of select="$nbsp"/>
				</div>
			</td>
			<td>
				<div class="topicTextLeft">
					<xsl:apply-templates select="camed:annotation"/>
					<xsl:value-of select="$nbsp"/>
				</div>
			</td>
		</tr>
		<xsl:apply-templates select="as:Attribute"/>
		<xsl:apply-templates select="as:Element"/>
	</xsl:template>
	<xsl:template match="as:Attribute">
		<tr>
			<td>
				<div class="topicTextLeft">
					<xsl:value-of select="@path"/>
				</div>
			</td>
			<td>
				<div class="topicTextLeft">
					<xsl:apply-templates select="as:Rule"/>
					<xsl:value-of select="$nbsp"/>
				</div>
			</td>
			<td>
				<div class="topicTextLeft">
					<xsl:apply-templates select="camed:annotation"/>
					<xsl:value-of select="$nbsp"/>
				</div>
			</td>
		</tr>
	</xsl:template>
	<xsl:template match="camed:annotation">
		<table border="1" width="100%">
			<xsl:apply-templates select="camed:documentation"/>
		</table>
	</xsl:template>
	<xsl:template match="camed:documentation">
		<tr>
			<th class="annotationHeader">
				<xsl:value-of select="@type"/>
			</th>
		</tr>
		<tr>
			<td class="annotationBody">
				<xsl:value-of select="."/>
			</td>
		</tr>
	</xsl:template>
	<xsl:template match="as:Rule">
		<table>
			<xsl:apply-templates select="as:constraint"/>
		</table>
	</xsl:template>
	<xsl:template match="as:constraint">
		<tr>
			<td>
				<div class="topicTextLeftSquashed">
					<xsl:choose>
						<xsl:when test="@condition">
<div class="keyword">if (<font color="black"><xsl:value-of select="@condition"/></font>) then</div> 
							<xsl:choose>
							<xsl:when test="not(contains(@action,'lookup('))">     			
								<div class="indentedTopicTextLeft"><xsl:value-of select="@action"/></div>
							</xsl:when>
							<xsl:otherwise>
								lookup
							</xsl:otherwise>
							</xsl:choose>
<div class="keyword">end if;</div>      							
						</xsl:when>
						<xsl:otherwise>
							<xsl:choose>
							<xsl:when test="not(contains(@action,'lookup('))">     			
								<div class="indentedTopicTextLeft"><xsl:value-of select="@action"/></div>
							</xsl:when>
							<xsl:otherwise>
								<div class="indentedTopicTextLeft">
									<xsl:value-of select="substring-before(@action,',')"/>,<xsl:element name="a"><xsl:attribute name="href">#<xsl:value-of select="substring-before(substring-after(@action,','),')')"/></xsl:attribute><xsl:value-of select="substring-after(@action,',')"/></xsl:element></div>
							</xsl:otherwise>
							</xsl:choose>
						</xsl:otherwise>
					</xsl:choose>
				</div>
			</td>
		</tr>
	</xsl:template>
	<xsl:template match="as:annotation"/>
	<xsl:template match="as:Structure">
		<h2>Structure</h2>
		<xsl:if test="string-length(@ID) > 0">
			<h2>
ID:   				<xsl:value-of select="@ID"/>
			</h2>
		</xsl:if>
		<xsl:if test="string-length(@reference) > 0">
			<h2>
Reference:   				<xsl:value-of select="@reference"/>
			</h2>
		</xsl:if>
		<h3>
Taxonomy:  			<xsl:value-of select="@taxonomy"/>
		</h3>
		<table border="1" class="topicTable">
			<tr>
				<td class="path">
					<div class="topicGroupHeaderCell">XPath locator</div>
				</td>
				<td class="rule">
					<div class="topicGroupHeaderCell">Rule(s)</div>
				</td>
				<td class="annotation">
					<div class="topicGroupHeaderCell">Annotation</div>
				</td>
			</tr>
			<xsl:apply-templates select="as:Element"/>
		</table>
	</xsl:template>

<xsl:template match="as:Extension">
	<xsl:apply-templates select="look:LookupList"/>
</xsl:template>

<xsl:template match="look:LookupList">
	<table border="0">
		<td>
			<h3>LookupList: <a name="#{@name}"><xsl:value-of select="@name"/></a></h3>
			<table border="1">
			<tr>
				<td class="annotation">
					<div class="topicGroupHeaderCell">Name</div>
				</td>
				<td class="annotation">
					<div class="topicGroupHeaderCell">Type</div>
				</td>
				<td class="annotation">
					<div class="topicGroupHeaderCell">Value</div>
				</td>
				<td class="annotation">
					<div class="topicGroupHeaderCell">Alternative</div>
				</td>
			</tr>
			<xsl:apply-templates select="look:item"/>
			</table>
		</td>
	</table>
</xsl:template>

<xsl:template match="look:item">
		<tr>
			<td>
				<div class="topicTextLeft">
					<xsl:value-of select="@name"/>
				</div>
			</td>
			<td>
				<div class="topicTextLeft">
					<xsl:if test="string-length(@type) > 0">
						<xsl:value-of select="@type"/>
					</xsl:if>
					<xsl:if test="string-length(@type) = 0">
						<font size="0.01em">.</font>
					</xsl:if>
				</div>
			</td>
			<td>
				<div class="topicTextLeft">
					<xsl:value-of select="."/>
				</div>
			</td>
			<td>
				<div class="topicTextLeft">
					<xsl:if test="string-length(@alt) > 0">
						<xsl:value-of select="@alt"/>
					</xsl:if>
					<xsl:if test="string-length(@alt) = 0">
						<font size="0.01em">.</font>
					</xsl:if>
				</div>
			</td>
		</tr>
</xsl:template>
</xsl:stylesheet>
<!-- Stylus Studio meta-information - (c) 2004-2006. Progress Software Corporation. All rights reserved.
<metaInformation>
<scenarios ><scenario default="yes" name="Scenario1" userelativepaths="yes" externalpreview="no" url="..\..\..\..\..\..\eclipse3.2\eclipse\test.xml" htmlbaseurl="" outputurl="" processortype="custom" useresolver="no" profilemode="0" profiledepth="" profilelength="" urlprofilexml="" commandline="java &#x2D;jar d:\saxon8.8\saxon8.jar &#x2D;w0 &#x2D;o %3  %1 %2" additionalpath="" additionalclasspath="" postprocessortype="none" postprocesscommandline="" postprocessadditionalpath="" postprocessgeneratedext="" validateoutput="no" validator="internal" customvalidator=""/></scenarios><MapperMetaTag><MapperInfo srcSchemaPathIsRelative="yes" srcSchemaInterpretAsXML="no" destSchemaPath="" destSchemaRoot="" destSchemaPathIsRelative="yes" destSchemaInterpretAsXML="no"/><MapperBlockPosition></MapperBlockPosition><TemplateContext></TemplateContext><MapperFilter side="source"></MapperFilter></MapperMetaTag>
</metaInformation>
-->
<!-- Stylus Studio meta-information - (c)1998-2002 eXcelon Corp.
<metaInformation>
<scenarios ><scenario default="yes" name="Scenario1" userelativepaths="yes" externalpreview="no" url="..\..\..\..\..\..\eclipse3.2\eclipse\temptoDoc.xml" htmlbaseurl="" processortype="internal" commandline="" additionalpath="" additionalclasspath="" postprocessortype="none" postprocesscommandline="" postprocessadditionalpath="" postprocessgeneratedext=""/></scenarios><MapperInfo srcSchemaPath="" srcSchemaRoot="" srcSchemaPathIsRelative="yes" srcSchemaInterpretAsXML="no" destSchemaPath="" destSchemaRoot="" destSchemaPathIsRelative="yes" destSchemaInterpretAsXML="no"/>
</metaInformation>
-->